/*    
    TLANG.CPP:    Multiple language support for Turbo Vision

    See TLANG.DOC for utilisation   
         

    Rem:   The translation from English is just performed (quickly)
           in French for demonstration purpose only.
           The exact translation (in French and other languages)
           have to be (and will be asap) performed.
*/
                                 


#define Uses_MsgBox
#define Uses_TApplication
#define Uses_TChDirDialog                     
#define Uses_TColorDialog
#define Uses_TDirListBox
#define Uses_TEditWindow
#define Uses_TFileDialog
#define Uses_TFileInfoPane
#define Uses_TFileList
#define Uses_TMenuBar
#define Uses_TMonoSelector
#define Uses_Uses_TStatusLine
#define Uses_TSystemError
#include "tvtools.h"
#include <help.h>

#include <string.h>

// For language choice
const unsigned short TLanguage = TL_English;

// This variable must be used everywhere in this file
// to avoid replacement by value due to optimization
static unsigned short Language = TL_English;

// Monthes must be 3 characters long
static const char * const Emonths[sizeof(TFileInfoPane::months)] =
       {                                  
        "","Jan","Feb","Mar","Apr","May","Jun",
        "Jul","Aug","Sep","Oct","Nov","Dec"
       };
static const char * const Fmonths[sizeof(TFileInfoPane::months)] =
       {
        "","Jan","Fv","Mar","Avr","Mai","Jun",
        "Jul","Ao","Sep","Oct","Nov","Dc"
       };


static const char * const Eerror[sizeof(TSystemError::errorString)] =
       {
        "Disk is write-protected in drive %c",            // 0
        "Unknown unit %c",                                // 1
        "Disk is not ready in drive %c",                  // 2
        "Critical error (unknown command) on drive %c",   // 3
        "Data integrity error on drive %c",               // 4 bad CRC
        "Critical error (bad request) on drive %c",       // 5
        "Seek error on drive %c",                         // 6
        "Unknown media type in drive %c",                 // 7
        "Sector not found on drive %c",                   // 8
        "Printer out of paper",                           // 9
        "Write fault on drive %c",                        // 10 - 0A
        "Read fault on drive %c",                         // 11 - 0B
        "General failure on drive %c",                    // 12 - 0C
        "Bad memory image of FAT detected",               // 13 - 0D
        "Device access error",                            // 14 - 0E
        "Insert diskette in drive %c"                     // 15 - 0F (invalid disk change)
       };

// Error messages must be max ? characters long
static const char * const Ferror[sizeof(TSystemError::errorString)] =
       {
        "Le disque %c est protg en criture",            // 0
        "Disque %c inconnu",                               // 1
        "Le disque %c n'est pas prt",                     // 2
        "Commande inconnue sur le disque %c",              // 3
        "Erreur d'integrit sur le disque %c",             // 4 bad CRC
        "Mauvaise requte sur le disque %c",               // 5
        "Erreur de positionnement sur le disque %c",       // 6
        "Format inconnu sur sur le disque %c",             // 7
        "Secteur introuvable sur le disque %c",            // 8
        "Plus de papier dans l'imprimante",                // 9
        "Erreur d'criture sur le disque %c",              // 10 - 0A
        "Erreur de lecture sur le disque %c",              // 11 - 0B
        "Panne gnrale sur le disque %c",                 // 12 - 0C
        "Mauvaise image de la FAT en mmoire",             // 13 - 0D
        "Erreur d'accs au priphrique",                  // 14 - 0E
        "Inserez une disquette dans l'unit %c"            // 15 - 0F (invalid disk change)
       };



void updateLanguage( void )
{
 switch( Language )
 {
  case TL_French:
     MsgBoxText::yesText = " ~O~ui ";
     MsgBoxText::noText = " ~N~on ";
     MsgBoxText::okText = "A~c~cepter";
     MsgBoxText::cancelText = "Annuler";
     MsgBoxText::warningText = "Attention";
     MsgBoxText::errorText = "Erreur";
     MsgBoxText::informationText = "Information";
     MsgBoxText::confirmText = "Confirmation";
                          
     TMonoSelector::normal = "Normal";
     TMonoSelector::highlight = "Sur-intensit";
     TMonoSelector::underline = "Soulign";
     TMonoSelector::inverse = "Inverse";

     TColorDialog::colors = "Couleurs";
     TColorDialog::groupText = "~G~roupe";
     TColorDialog::itemText = "~E~lment";
     TColorDialog::forText = "~T~exte";
     TColorDialog::bakText = "~F~ond";
     TColorDialog::textText = "Texte";
     TColorDialog::colorText = "Couleur";

     TDirListBox::drives = "Disques";
     TChDirDialog::changeDirTitle = "Changer de rpertoire";
     TChDirDialog::dirNameText = "~N~om de rpertoire";
     TChDirDialog::dirTreeText = "~A~rbre de rpertoire";
     TChDirDialog::chdirText = "~C~hanger";
     TChDirDialog::revertText = "~I~nverser";
     TChDirDialog::helpText = "Aide";
     TChDirDialog::invalidText = "\03Rpertoire invalide";

     TFileDialog::filesText = "~F~ichiers";
     TFileDialog::openText = " ~O~uvrir  ";
     TFileDialog::replaceText = "~R~emplacer";
     TFileDialog::clearText = " ~E~ffacer" ;
     TFileDialog::invalidDriveText = "\03Disque ou rpertoire invalide";
     TFileDialog::invalidFileText = "\03Fichier invalide";
     TFileList::tooManyFiles = "Trop de fichiers.";

     TEditWindow::clipboardTitle = "Presse-papiers";
     TEditWindow::untitled = "Sans titre";

     TProgram::exitText = "~Alt-X~ Sortie";

     TSystemError::sRetryOrCancel = "~Enter~ Ressayer  ~Esc~ Annuler";
     TSystemError::critErrorString = "Erreur critique %d sur le disque %d";

     THelpFile::noHelpMsg = "\n Pas d'aide disponible dans ce contexte.";

     memcpy( (void*)TFileInfoPane::months, (void*)Fmonths, sizeof(TFileInfoPane::months) );;
     memcpy( (void*)TSystemError::errorString, (void*)Ferror, sizeof(TSystemError::errorString) );

     break;

  case TL_Dutch: // ???
  case TL_German: // ???

  default:
     // Buttons messages (must be max 7 characters long ?)
     MsgBoxText::yesText = " ~Y~es  ";
     MsgBoxText::noText = "  ~N~o  ";
     MsgBoxText::okText = "  O~K~  ";
     MsgBoxText::cancelText = "Cancel";  

     // Titles 
     MsgBoxText::warningText = "Warning";
     MsgBoxText::errorText = "Error";     // also error msg in TCalculator
     MsgBoxText::informationText = "Information";
     MsgBoxText::confirmText = "Confirm";

     // Used as TSItem of a TCluster (bounds are parameters to TMonoSelector)
     TMonoSelector::normal = "Normal";
     TMonoSelector::highlight = "Highlight";
     TMonoSelector::underline = "Underline";
     TMonoSelector::inverse = "Inverse";
                 
     // inside TColorDialog
     TColorDialog::colors = "Colors";         // Title
     TColorDialog::groupText = "~G~roup";     // Label
     TColorDialog::itemText = "~I~tem";       // Label
     TColorDialog::forText = "~F~oreground";  // Label
     TColorDialog::bakText = "~B~ackground";  // Label
     TColorDialog::textText = "Text ";        // Title
     TColorDialog::colorText = "Color";       // Label
             
     // inside TChDirDialog
     TDirListBox::drives = "Drives";                     // inside directory tree
     TChDirDialog::changeDirTitle = "Change Directory";  // Title
     TChDirDialog::dirNameText = "Directory ~n~ame";     // Label
     TChDirDialog::dirTreeText = "Directory ~t~ree";     // Label
     TChDirDialog::chdirText = "~C~hdir ";               // Button
     TChDirDialog::revertText = "~R~evert";              // Button
     TChDirDialog::invalidText = "\03Invalid directory"; // Msg box string
     TChDirDialog::helpText = "Help";        // Button (also TFileDialog)
                                             // & Help window title

     // inside TFileDialog
     TFileDialog::filesText = "~F~iles";        // Label
     TFileDialog::openText = " ~O~pen ";        // Button
     TFileDialog::replaceText = "~R~eplace";    // Button
     TFileDialog::clearText = "~C~lear";        // Button
     TFileDialog::invalidDriveText = "\03Invalid drive or directory"; // Msg box string
     TFileDialog::invalidFileText = "\03Invalid file name.";          // Msg box string
     TFileList::tooManyFiles = "Too many files.";                     // Msg box string

     TEditWindow::clipboardTitle = "Clipboard";     // Title
     TEditWindow::untitled = "Untitled";            // Title

     TProgram::exitText = "~Alt-X~ Exit";           // Status Line        
                                                                      
     // Status Line hardware critical error message:
     TSystemError::sRetryOrCancel = "~Enter~ Retry  ~Esc~ Cancel";
     TSystemError::critErrorString = "critical error %d on drive %d";

     THelpFile::noHelpMsg = "\n No help available in this context.";   // Msg box string

     memcpy( (void*)TFileInfoPane::months, (void*)Emonths, sizeof(TFileInfoPane::months) );;
     memcpy( (void*)TSystemError::errorString, (void*)Eerror, sizeof(TSystemError::errorString) );
    }

 TChDirDialog::okText = TColorDialog::okText =
  TFileDialog::okText = MsgBoxText::okText;
 TColorDialog::cancelText = TFileDialog::cancelText =
  MsgBoxText::cancelText;
 TChDirDialog::drivesText = TDirListBox::drives;
 TFileDialog::helpText = TChDirDialog::helpText;


 // Modify menu & status line
#if 0
 if ( TApplication::menuBar )
    {
     delete TApplication::menuBar->menu;
     TMenuBar *mb = TApplication::application->initMenuBar( TApplication::application->getExtent() );
     TApplication::menuBar->menu = mb->menu;
     mb->menu = 0;
     delete mb;
     TApplication::application->insert( TApplication::menuBar );
     TApplication::menuBar->draw();
    }
#endif
// if ( TApplication::application->statusLine )
}      

#pragma startup updateLanguage 64


void changeLanguage( TLANGUAGE lang )
{
 if ( lang == Language ) return;

 Language = lang;
 *(unsigned short*)&TLanguage = Language;
 updateLanguage();
}
